
--
-- Структура таблицы `direct_direct_config`
--

DROP TABLE IF EXISTS `direct_direct_config`;
CREATE TABLE IF NOT EXISTS `direct_direct_config` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Первичный ключ',
  `key` varchar(255) DEFAULT NULL COMMENT 'Название константы',
  `name` varchar(1024) DEFAULT NULL COMMENT 'Описание константы',
  `value` varchar(255) DEFAULT NULL COMMENT 'Значение константы',
  `description` text COMMENT 'Описание',
  `type` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Тип поля ввода 0 - строка, 1 - логическое да или нет',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '0 - выключен, 1 - включен, 2 - не виден',
  PRIMARY KEY (`id`),
  KEY `key` (`key`),
  KEY `status` (`status`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=17 ;

--
-- Дамп данных таблицы `direct_direct_config`
--

INSERT INTO `direct_direct_config` (`id`, `key`, `name`, `value`, `description`, `type`, `status`) VALUES
(1, 'number', 'Количество записей на страницу', '50', 'Количество записей выводимых на страницу по умолчанию', 0, 1),
(2, 'statistic', 'Хранить статистику усредненную по дням (в днях)', '7', 'Количество дней, в течении которых хранится усредненная статистика по дням', 0, 1),
(3, 'statistic_price', 'Хранить статистику в реальном времени (в днях)', '1', 'Количество дней, в течении которых хранится статистика изменения ставок', 0, 1),
(4, 'statistic_conversion', 'Получать конверсии за следующее количество дней', '365', 'Количество дней, за которые получаются конверсии по фразам. Диапазон значений от 1 до 366 дней.', 0, 1),
(5, 'auction_status', 'Обновлять ставки только у запущенных объявлений и фраз', '1', '1 - обновлять только у активных (идут показы), 0 - обновлять у всех, в том числе остановленных', 1, 1),
(6, 'priority_ctr', 'Приоритизация при CTR за 28 дней меньше, %', '0', 'Механизм приоритизации обновления ставок. 0 - выключен. Порог низкого CTR, при котором ставки будут обновляться реже. Пример: 0.5', 0, 1),
(7, 'priority_interval', 'Приоритизация: интервал между обновлениями ставок, мин.', '60', 'Механизм приоритизации обновления ставок. Интервал обновления ставок для низкого CTR. ', 0, 1),
(8, 'auction', 'Количество групп за один запрос при обновлении ставок', '1000', 'Количество групп за один запрос при обновлении ставок. Увеличивает потребляемую память, но при этом увеличивается скорость обновления ставок c Яндекс.Директ. Максимум 1000', 0, 1),
(9, 'sinchronize', 'Количество объявлений за один запрос при синхронизации', '2000', 'Количество объявлений за один запрос при синхронизации. Увеличивает потребляемую память, но при этом увеличивается скорость синхронизации данных c Яндекс.Директ. Максимум 2000', 0, 1),
(10, 'max_execution_time', 'Максимальное время выполнения скрипта в секундах', '3600', 'Это время, после которого программа принимает решение, что процесс завис и перезапускает его (должно быть больше времени выполнения любого процесса). 1 час = 3600 секунд, 3 часа = 10800 секунд', 0, 1),
(11, 'timezone', 'Временная зона', '0', 'Часовой пояс - количество часов в плюс или в минус относительно Московского времени.', 0, 1),
(12, 'xml_user', 'Логин Яндекс.XML', '', 'Логин для доступа к Яндекс.XML (параметр в запросе: user) - https://xml.yandex.ru/', 0, 1),
(13, 'xml_key', 'Ключ Яндекс.XML', '', 'Ключ для доступа к Яндекс.XML (параметр в запросе: key) - https://xml.yandex.ru/', 0, 1),
(14, 'xml_region', 'Регион Яндекс.XML', '213', 'Регион поиска Яндекс.XML (параметр в запросе: lr, Москва - 213, Санкт-Петербург - 2, Пермь - 50, Самара - 51, Тольятти - 240, Чебоксары - 45, Казань - 43, Томск - 67, Новосибирск - 65, Екатеринбург - 54, Челябинск - 56, Сургут - 973, Ростов-на-Дону - 39) - https://xml.yandex.ru/', 0, 1),
(15, 'xml_number', 'Количество фраз за раз Яндекс.XML', '10', 'Количество фраз за один запуск Яндекс.XML - https://xml.yandex.ru/', 0, 1),
(16, 'api_version', 'АПИ 5', '1', '1 - АПИ 4 и АПИ 5, 0 - Только АПИ 4', 1, 1),
(17, 'time_yandex', 'Разница между временем на Яндекс и временем на сервере в минутах', '1', 'Разница между временем на Яндекс и временем на сервере в минутах. На сколько отстают или спешат часы на сервере относительно часов в Яндекс.АПИ. Вычисляется автоматически во время синхронизации. ', 0, 2);

-- --------------------------------------------------------

--
-- Структура таблицы `direct_article`
--

DROP TABLE IF EXISTS `direct_article`;
CREATE TABLE IF NOT EXISTS `direct_article` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `parent` int(11) NOT NULL DEFAULT '0' COMMENT 'Ссылка на id',
  `key` varchar(255) DEFAULT NULL COMMENT 'Ключ или алиас',
  `name` varchar(1024) NOT NULL,
  `body` mediumtext,
  `title` varchar(1024) DEFAULT NULL COMMENT 'Заголовок для меню',
  `announce` text COMMENT 'Анонс',
  `sort` int(11) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1',
  `time` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `sort` (`sort`),
  KEY `status` (`status`),
  KEY `time` (`time`),
  KEY `key` (`key`),
  KEY `parent` (`parent`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='Таблица статей' AUTO_INCREMENT=2 ;

--
-- Дамп данных таблицы `direct_article`
--

INSERT INTO `direct_article` (`id`, `parent`, `key`, `name`, `body`, `title`, `announce`, `sort`, `status`, `time`) VALUES
(1, 0, 'documentation', 'Документация', '<ol>\r\n      <!--admin--><li><strong>Настройка программы</strong>\r\n      <ol>\r\n        <li>Перейдите на страницу \r\n        "<a href="/user/user/get/param/group/account">Аккаунты</a>"</li>\r\n        <li>Нажмите "Добавить аккаунт Яндекс.Директ" и вбейте обязательные поля: \r\n        <ul>\r\n          <li>Логин от аккаунта яндекса</li>\r\n          <li>Пароль для доступа в программу</li>\r\n        </ul></li>\r\n		<li>Перейдите на страницу "<a href="/user/user/get/param/group/account">Аккаунты</a>" и нажмите кнопку "Получить токен". Предварительно убедитесь, что вы авторизованы в этом же браузере в <a href="http://direct.yandex.ru/" target="_blank">Яндекс.Директ</a> под соответстующим логином.</li>\r\n		<li>Поместить файл cron.php в планировщик заданий КРОНТАБ<br>\r\n		На странице <a href="/direct/index/config/">настройки</a> в строке Крон вы найдете пример директивы, которую нужно прописать в крон.\r\n      </ol></li>\r\n	  <li><strong>Настройки в интерфейсе Яндекс.Директ</strong> <br>\r\n	  <ol>\r\n	  <li>В настройках компании Яндекс.Директ (<a href="http://direct.yandex.ru/" target="_blank">http://direct.yandex.ru</a>) в пункте "Стратегия" выбрать "Наивысшая доступная позиция".</li>\r\n	  <li>Если в программе включена стратегия РСЯ или галочка РСЯ, то для корректной работы обновления ставок в рекламной сети Яндекса (РСЯ) должно быть включено "Независимое управление для разных типов площадок" в интерфейсе Яндекс.Директ.</li>\r\n	  <li>Необходимо использовать "профессиональный интерфейс".</li>\r\n	  </ol>\r\n	  </li>\r\n	  <!--/admin-->\r\n      <li><strong>Стратегии</strong><br>\r\n	  В программе предустановлены встроенные стратегии управления ставками. В разделе «Стратегии» можно создавать собственные индивидуальные стратегии.\r\n      <ol>\r\n		<li>Наследовать\r\n        <br />Эта стратегия означает, что стратегия берется у вышестоящего\r\n        элемента (компании, объявления, фразы)</li>\r\n        <li>Гарантия 4 место, если максимальная ставка, то минимальная ставка\r\n        <br />Эта стратегия означает, что объявление будет показываться под\r\n        результатми поиска по цене определяемой по формуле:\r\n        <br />«Ставка» = «Цена входа в гарантию» + («Цена 1 места гарантии» *\r\n        (Если установлена галочка «До первого места» то 1, иначе 0) - (Если установлена галочка «До первого места» то 1, иначе -1) * «Цена\r\n        входа в гарантию») * «Наценка в %» / 100 + «Наценка в руб.».</li>\r\n        <li>Спецразмещение 3 место, если максимальная ставка, то гарантия 4 место, если максимальная ставка, то минимальная ставка\r\n        <br />Эта стратегия означает, что объявление будет показываться над\r\n        результатми поиска по цене определяемой по формуле:\r\n        <br />«Ставка» = «Цена входа в спецразмещение» + («Цена 1 места\r\n        спецразмещения» * (Если установлена галочка «До первого места» то 1,\r\n        иначе 0) - (Если установлена галочка «До первого места» то 1, иначе -1) * «Цена входа в спецразмещение») * «Наценка в %» / 100 + «Наценка\r\n        в руб.».</li>\r\n        <li>Спецразмещение 3 место, если максимальная ставка, то минимальная ставка (максимальный CTR)\r\n        <br />То же что и предыдущая стратегия, за исключением того, что при достижении максимальной ставки объявление пропадает. Это увеличивает CTR.</li>\r\n		\r\n		<li>1 место спецразмещения, если максимальная ставка, то минимальная ставка<br>\r\n		Стратегия, которая удерживает объявление на 1 месте над результатами поиска.<br>\r\n		Формула: «Ставка» = «Цена 1 места спецразмещения» + «Цена 1 места\r\n        спецразмещения» * «Наценка в %» / 100 + «Наценка\r\n        в руб.».\r\n		</li>\r\n		<li>2 место спецразмещения, если максимальная ставка, то минимальная ставка<br>\r\n		Стратегия, которая удерживает объявление на 2 месте над результатами поиска.<br>\r\n		Формула: «Ставка» = «Цена 2 места спецразмещения» + «Цена 2 места\r\n        спецразмещения» * «Наценка в %» / 100 + «Наценка\r\n        в руб.».\r\n		</li>\r\n        <li>Не обновлять ставки\r\n        <br />Отключает обновление ставок, через программу. Ставки будут\r\n        назначаться через интефейс Яндекс.Директ.</li>\r\n      </ol></li>\r\n      <li><strong>Параметры стратегий</strong>\r\n      <ol>\r\n        <li>Наценка в %\r\n        <br />Это добавочная цена к «Цене входа в гарантию или\r\n        спецразмещение». Если установлена галочка «До первого места», то\r\n        берется процент от разницы между «Ценой 1 места» и «Ценой входа», в\r\n        противном случае процент высчитывается от «Цены входа»</li>\r\n        <li>Разница до первого места<br>\r\n		Галочка «До первого места» - это\r\n        наценка в процентах от разницы между «Ценой 1 места» и «Ценой входа», в\r\n        противном случае процент высчитывается от «Цены входа»\r\n       </li>\r\n        <li>Наценка в единицах валюты\r\n        <br />Это добавочная цена к «Цене входа в гарантию или\r\n        спецразмещение».</li>\r\n        <li>Максимальная ставка, \r\n        <br />Это ограничение максимально возможной ставки. Ставка не\r\n        поднимется выше, чем задано. 0 - без ограничений.</li>\r\n        <li>Бюджет, руб./день\r\n        <br />Ограничение дневного бюджета для компании. 0 - без\r\n        ограничений.</li>\r\n      </ol></li>\r\n	  \r\n	  <li><strong>СТАТИСТИКА</strong><br>\r\n	  Статистика обновлений ставок, цены на поиске, показов, кликов, CTR, расходов с возможностью экспорта в EXCEL(CSV).<br>\r\n	  Время хранения статистики устанавливается в разделе «<a href="/direct/index/config/">Настройки</a>» в пункте «Хранить статистику (в днях)»\r\n	  </li>\r\n	  \r\n	  <li><strong>ФОРМУЛЫ (Индивидуальные стратегии)</strong><br>\r\n	  В разделе «Стратегии» можно создавать собственные стратегии<br>\r\nСинтаксис написания формул для стратегий языка программирования <strong><a href="http://php.net" target="_blank">PHP</a></strong> (полная поддержка).<br>\r\nДля удобства имена доступных переменных можно задавать без "$", а доступных функций (методов) без скобок "()"<br><br>\r\n<strong>Доступные свойства (переменные)</strong><br>\r\n							\r\n							Параметры доступные для формул. Пример: price=premium_min + premium_min*percent/100 + add; if (price>maximum) price=min_price; \r\n							\r\n							<ol>\r\n								<li>price - ставка</li>\r\n																	<li>position1 (premium_max) - 1 место спецразмещения ставка</li>\r\n									<li>position2 (second_price) - 2 место спецразмещения ставка</li>\r\n									<li>position3 (premium_min) - 3 место спецразмещения ставка (цена входа)</li>\r\n									<li>position4 (max) - 4 место гарантия ставка</li>\r\n									<li>position5 (down_second_price) - 5 место гарантия ставка</li>\r\n									<li>position6 (down_second_price_min) - 6 место гарантия ставка</li>\r\n									<li>position7 (min) - 7 место гарантия ставка (цена входа)</li>\r\n									<li>price1 - списываемая цена клика за 1 место</li>\r\n									<li>price2 - списываемая цена клика за 2 место</li>\r\n									<li>price3 - списываемая цена клика за 3 место</li>\r\n									<li>price4 - списываемая цена клика за 4 место</li>\r\n									<li>price5 - списываемая цена клика за 5 место</li>\r\n									<li>price6 - списываемая цена клика за 6 место</li>\r\n									<li>price7 - списываемая цена клика за 7 место</li>\r\n								<li>real_price - цена действующая на поиске</li>\r\n\r\n																<li>step - шаг торгов в валюте кампании (0.1 руб.)</li>\r\n <li>min_price - минимальная ставка в валюте кампании (0.3 руб.)</li>\r\n								<li>max_price - максимальная ставка в валюте кампании (2500 руб.)</li>\r\n								<li>maximum - ограничение максимальной ставки в валюте кампании</li>\r\n								<li>percent - наценка в процентах</li>\r\n								<li>add - наценка в валюте кампании</li>\r\n								<li>type - признак разницы до 1 места. Значения: 1 - да, 0 - нет</li>\r\n								<li>budget - ограничение бюджета по ключевой фразе</li>\r\n								<li>sum - расход за сегодня по ключевой фразе</li>\r\n								<li>click - клики за сегодня по ключевой фразе</li>\r\n								<li>show - показы за сегодня по ключевой фразе</li>\r\n								<li>ctr - ЦТР за сегодня по ключевой фразе, %</li>\r\n								<li>click28 - клики среднее за 28 дней по ключевой фразе</li>\r\n								<li>show28 - показы среднее за 28 дней по ключевой фразе</li>\r\n								<li>ctr28 - ЦТР среднее за 28 дней по ключевой фразе, %</li>								\r\n								<li>banner_budget - ограничение бюджета по компании</li>\r\n								<li>banner_sum - расход за сегодня по объявлению</li>\r\n								<li>banner_click - клики за сегодня по объявлению</li>\r\n								<li>banner_show - показы за сегодня по объявлению</li>\r\n								<li>banner_ctr - ЦТР за сегодня по объявлению, %</li>\r\n								<li>banner_click28 - клики среднее за 28 дней по объявлению</li>\r\n								<li>banner_show28 - показы среднее за 28 дней по объявлению</li>\r\n								<li>banner_ctr28 - ЦТР среднее за 28 дней по объявлению, %</li>								\r\n								<li>company_budget - ограничение бюджета по компании</li>\r\n								<li>company_sum - расход за сегодня по компании</li>\r\n								<li>company_click - клики за сегодня по компании</li>\r\n								<li>company_show - показы за сегодня по компании</li>\r\n								<li>company_ctr - ЦТР за сегодня по компании, %</li>\r\n								<li>company_click28 - клики среднее за 28 дней по компании</li>\r\n								<li>company_show28 - показы среднее за 28 дней по компании</li>\r\n								<li>company_ctr28 - ЦТР среднее за 28 дней по компании, %</li>								\r\n								<li>datetime - текущие дата и время, формат YYYY-MM-DD HH:II:SS</li>\r\n								<li>date - текущая дата, формат YYYY-MM-DD</li>\r\n								<li>time - текущее время, формат HH:II:SS</li>\r\n								<li>week - текущий день недели, формат 0 - воскресенье, 1 - понедельник...6 - суббота</li>\r\n								<li>depth - Глубина просмотра сайта кампании при переходе с поиска (Яндекс.Метрика)</li>\r\n								<li>depth_context - глубина просмотра сайта кампании при переходе из Рекламной сети Яндекса (Яндекс.Метрика)</li>\r\n								<li>conversion - количество достигнутых целей кампании Яндекс.Метрики при переходе с поиска (Яндекс.Метрика)</li>\r\n								<li>conversion_context - количество достигнутых целей кампании Яндекс.Метрики при переходе из Рекламной сети Яндекса (Яндекс.Метрика)</li>\r\n								<li>cost - цена достижения цели кампании  Яндекс.Метрики при переходе с поиска (Яндекс.Метрика)</li>\r\n								<li>cost_context - цена достижения цели кампании Яндекс.Метрики при переходе из Рекламной сети Яндекса (Яндекс.Метрика)</li>\r\n	<li>position_value - позиция фразы в результатах поиска (Яндекс.XML)</li>\r\n							</ol><br><br><strong>Доступные методы (функции)</strong><br>\r\n							\r\n							Функции доступные для формул. Пример: if (company_sum>company_budget) company_stop; else company_start; \r\n							\r\n							<ol>\r\n								<li>stop - Остановить ключевую фразу</li>\r\n								<li>start - Запустить ключевую фразу</li>\r\n								<li>banner_stop - Остановить объявление</li>\r\n								<li>banner_start - Запустить объявление</li>\r\n								<li>company_stop - Остановить компанию</li>\r\n								<li>company_start - Запустить компанию</li>\r\n								\r\n							</ol>\r\n							</li>\r\n    </ol>', NULL, NULL, 0, 1, '2014-03-11 17:55:14');


-- --------------------------------------------------------

--
-- Структура таблицы `direct_direct_tag`
--

DROP TABLE IF EXISTS `direct_direct_tag`;
CREATE TABLE IF NOT EXISTS `direct_direct_tag` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Первичный ключ',
  `company` int(11) NOT NULL DEFAULT '0' COMMENT 'Кампания',
  `name` varchar(255) DEFAULT NULL COMMENT 'Наименование',
  `sort` int(11) NOT NULL DEFAULT '0' COMMENT 'Сортировка',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '1 - активна, 0 - не активна',
  `datetime` datetime DEFAULT NULL COMMENT 'Дата обновления',
  PRIMARY KEY (`id`),
  KEY `sort` (`sort`),
  KEY `status` (`status`),
  KEY `company` (`company`),
  KEY `datetime` (`datetime`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='Таблица меток' AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Структура таблицы `direct_direct_tag_banner`
--

DROP TABLE IF EXISTS `direct_direct_tag_banner`;
CREATE TABLE IF NOT EXISTS `direct_direct_tag_banner` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Тег',
  `banner` int(11) NOT NULL DEFAULT '0' COMMENT 'Объявление',
  `group` int(11) NOT NULL DEFAULT '0' COMMENT 'Группа',
  PRIMARY KEY (`id`,`banner`),
  KEY `banner` (`banner`),
  KEY `group` (`group`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='Таблица связей меток' AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Структура таблицы `direct_api_yandex_xml_limit`
--

DROP TABLE IF EXISTS `direct_api_yandex_xml_limit`;
CREATE TABLE IF NOT EXISTS `direct_api_yandex_xml_limit` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Первичный ключ',
  `key` varchar(30) DEFAULT NULL COMMENT 'Ассоциативный ключ - IP сервера',
  `value` int(11) NOT NULL DEFAULT '0' COMMENT 'Количество запросов',
  `status` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Статус: 1 - лимит исчерпан, 0 - не исчерпан',
  `date` date DEFAULT NULL COMMENT 'Дата',
  PRIMARY KEY (`id`),
  UNIQUE KEY `key` (`key`),
  KEY `status` (`status`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='Таблица АПИ Яндекс.XML - Лимиты' AUTO_INCREMENT=1 ;

--
-- Структура таблицы `direct_direct_currency`
--

DROP TABLE IF EXISTS `direct_direct_currency`;
CREATE TABLE IF NOT EXISTS `direct_direct_currency` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Первичный ключ',
  `key` varchar(3) DEFAULT NULL COMMENT 'Код валюты',
  `name` varchar(255) NOT NULL COMMENT 'Наименование',
  `value` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Курс',
  `code` varchar(50) DEFAULT NULL COMMENT 'Сокращение для валюты',
  `tax` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Налог (НДС), %',
  `min` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Минимальная ставка',
  `max` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Масимальная ставка',
  `round` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Число знаков после запятов при округлении',
  PRIMARY KEY (`id`),
  UNIQUE KEY `key` (`key`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='Валюты' AUTO_INCREMENT=8 ;

--
-- Дамп данных таблицы `direct_direct_currency`
--

INSERT INTO `direct_direct_currency` (`id`, `key`, `name`, `value`, `code`, `tax`, `min`, `max`, `round`) VALUES
(1, 'RUB', 'Рубли', '30.00', '<strike>Р</strike>', '18.00', '0.30', '2500.00', 1),
(2, 'USD', 'Доллары', '0.85', '$', '0.00', '0.01', '70.00', 2),
(3, 'CHF', 'Швейцарский франк', '0.77', '&#8355;', '0.00', '0.01', '60.00', 2),
(4, 'EUR', 'Евро', '0.65', '&euro;', '0.00', '0.01', '50.00', 2),
(5, 'KZT', 'Казахстанский тенге', '130.00', '&#8376;', '0.00', '1.00', '13000.00', 0),
(6, 'TRY', 'Турецкая Лира', '1.70', '&#8356;', '0.00', '0.01', '150.00', 2),
(7, 'UAH', 'Украинская гривна', '8.10', '&#8372;', '20.00', '0.08', '900.00', 2);

DROP TABLE IF EXISTS `direct_framework_error`;
CREATE TABLE IF NOT EXISTS `direct_framework_error` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Первичный ключ',
  `key` varchar(255) DEFAULT NULL COMMENT 'Метод',
  `file` varchar(1024) DEFAULT NULL COMMENT 'Файл',
  `line` int(11) NOT NULL DEFAULT '0' COMMENT 'Строка',
  `code` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) DEFAULT NULL COMMENT 'Наименование',
  `value` text,
  `session` bigint(20) NOT NULL DEFAULT '0' COMMENT 'Уникальный идентификатор скрипта (время в микросекундах)',
  `datetime` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `key` (`key`),
  KEY `datetime` (`datetime`),
  KEY `session` (`session`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='Таблица ошибок' AUTO_INCREMENT=1 ;

UPDATE `direct_direct_company` SET `time`=NULL;
UPDATE `direct_direct_phrase` SET `time`=NULL;
DELETE FROM `direct_direct_company` WHERE `account`=0;
DELETE FROM `direct_direct_banner` WHERE `account`=0;
DELETE FROM `direct_direct_phrase` WHERE `account`=0;




REPLACE `direct_direct_strategy` (`id`, `key`, `name`, `value`, `sort`, `default`, `status`) VALUES
(-2, NULL, 'Сбор статистики (не обновляя ставки)', NULL, 0, 1, 2),
(-1, NULL, 'Не обновлять ставки', NULL, 0, 1, 2),
(1, NULL, '7 место гарантии (последнее место снизу)', 'if (type>0) price=position7 + (position4-position7)*percent/100 + add; else price=position7 + position7*percent/100 + add; \r\nif (fixed>0) price=fixed;\r\nif (maximum>0 AND price>maximum) price=maximum;\r\nif (company_budget>0 AND company_sum>=company_budget) company_stop; elseif (company_budget>0) company_start;\r\n/* РСЯ */\r\nif (context>0) {\r\ncontext_price=context_optimum; \r\nif (context_price<=0) if (context_fixed>0) context_price=context_fixed; else context_price=min_price;\r\nif (context_minimum>0 AND context_price<context_minimum) context_price=context_minimum;\r\nif (context_maximum>0 AND context_price>context_maximum) context_price=context_maximum;\r\n}', 0, 0, 1),
(2, NULL, '3 место спец. (последнее место сверху), если максимальная ставка, то 7 место гарантии (последнее место снизу)', 'if (type>0) price=position3 + (position1-position3)*percent/100 + add; else price=position3 + position3*percent/100 + add;\r\nif (maximum>0 AND price>maximum)  if (position3<=maximum) price=maximum; elseif (type>0) price=position7 + (position4-position7)*percent/100 + add; else price=position7 + position7*percent/100 + add;\r\nif (fixed>0) price=fixed;\r\nif (maximum>0 AND price>maximum) price=maximum;\r\nif (company_budget>0 AND company_sum>=company_budget) company_stop; elseif (company_budget>0) company_start;\r\n/* РСЯ */\r\nif (context>0) {\r\ncontext_price=context_optimum; \r\nif (context_price<=0) if (context_fixed>0) context_price=context_fixed; else context_price=min_price;\r\nif (context_minimum>0 AND context_price<context_minimum) context_price=context_minimum;\r\nif (context_maximum>0 AND context_price>context_maximum) context_price=context_maximum;\r\n}', 0, 0, 1),
(3, NULL, '3 место спец. (максимальный CTR), если максимальная ставка, то пропадаем (2 страница)', 'if (type>0) price=position3 + (position1-position3)*percent/100 + add; else price=position3 + position3*percent/100 + add; \r\nif (maximum>0 AND price>maximum)  if (position3<=maximum) price=maximum; else price=min_price;\r\nif (company_budget>0 AND company_sum>=company_budget) company_stop; elseif (company_budget>0) company_start;\r\n/* РСЯ */\r\nif (context>0) {\r\ncontext_price=context_optimum; \r\nif (context_price<=0) if (context_fixed>0) context_price=context_fixed; else context_price=min_price;\r\nif (context_minimum>0 AND context_price<context_minimum) context_price=context_minimum;\r\nif (context_maximum>0 AND context_price>context_maximum) context_price=context_maximum;\r\n}', 0, 0, 1),
(4, NULL, '1 место спецразмещения (самый верх)', 'price=position1 + position1*percent/100 + add;\r\nif (fixed>0) price=fixed;\r\nif (maximum>0 AND price>maximum)  price=maximum;\r\nif (company_budget>0 AND company_sum>=company_budget) company_stop; elseif (company_budget>0) company_start;\r\n/* РСЯ */\r\nif (context>0) {\r\ncontext_price=context_optimum; \r\nif (context_price<=0) if (context_fixed>0) context_price=context_fixed; else context_price=min_price;\r\nif (context_minimum>0 AND context_price<context_minimum) context_price=context_minimum;\r\nif (context_maximum>0 AND context_price>context_maximum) context_price=context_maximum;\r\n}', 0, 0, 1),
(5, NULL, '2 место спецразмещения', 'if (position2>0) {price=position2 + position2*percent/100 + add; if (price==position2) price=position2;} elseif (percent>0 OR add>0) price=position3+position3*percent/100 + add; else price=position3;\r\nif (fixed>0) price=fixed;\r\nif (maximum>0 AND price>maximum)  price=maximum;\r\nif (company_budget>0 AND company_sum>=company_budget) company_stop; elseif (company_budget>0) company_start;\r\n/* РСЯ */\r\nif (context>0) {\r\ncontext_price=context_optimum; \r\nif (context_price<=0) if (context_fixed>0) context_price=context_fixed; else context_price=min_price;\r\nif (context_minimum>0 AND context_price<context_minimum) context_price=context_minimum;\r\nif (context_maximum>0 AND context_price>context_maximum) context_price=context_maximum;\r\n}', 0, 0, 1),
(6, NULL, 'Тематические площадки (РСЯ)', 'price=0;\r\ncontext=1;\r\nif (context>0) {\r\ncontext_price=context_optimum; \r\nif (context_price<=0) if (context_fixed>0) context_price=context_fixed; else context_price=min_price;\r\nif (context_minimum>0 AND context_price<context_minimum) context_price=context_minimum;\r\nif (context_maximum>0 AND context_price>context_maximum) context_price=context_maximum;\r\n}\r\nif (company_budget>0 AND company_sum>=company_budget) company_stop; elseif (company_budget>0) company_start;', 0, 0, 1);
UPDATE `direct_direct_strategy` SET `id`=0 WHERE `id`=7 AND `status`=2;
UPDATE `direct_direct_strategy` SET `name`='Наследовать' WHERE `id`=0;

--
-- Структура таблицы `direct_direct_statistic`
--

DROP TABLE IF EXISTS `direct_direct_statistic`;
CREATE TABLE IF NOT EXISTS `direct_direct_statistic` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT 'Первичный ключ',
  `account` int(11) NOT NULL DEFAULT '0' COMMENT 'Аккунт Яндекс.Директ',
  `user` int(11) NOT NULL DEFAULT '0' COMMENT 'Пользователь',
  `company` int(11) NOT NULL DEFAULT '0' COMMENT 'Компания',
  `group` int(11) NOT NULL DEFAULT '0' COMMENT 'Группа объявлений',
  `banner` int(11) NOT NULL DEFAULT '0' COMMENT 'Баннер',
  `phrase` bigint(20) NOT NULL DEFAULT '0' COMMENT 'Фраза',
  `currency` int(11) NOT NULL DEFAULT '0' COMMENT 'Валюта',
  `count` int(11) NOT NULL DEFAULT '0' COMMENT 'Знаменатель для вычисления среднего',
  `price` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Ставка',
  `real_price` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Реальная цена',
  `position1` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Ставка за 1 место',
  `position2` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Ставка за 2 место',
  `position3` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Ставка за 3 место',
  `position4` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Ставка за 4 место',
  `position5` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Ставка за 5 место',
  `position6` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Ставка за 6 место',
  `position7` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Ставка за 7 место',
  `price1` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Списываемая цена клика за 1 место',
  `price2` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Списываемая цена клика за 2 место',
  `price3` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Списываемая цена клика за 3 место',
  `price4` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Списываемая цена клика за 4 место',
  `price5` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Списываемая цена клика за 5 место',
  `price6` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Списываемая цена клика за 6 место',
  `price7` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Списываемая цена клика за 7 место',
  `context` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Ставка РСЯ',
  `context_percent` decimal(5,2) NOT NULL DEFAULT '0.00' COMMENT 'Охват РСЯ',
  `context_max` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Максимальный охват РСЯ',
  `position` decimal(2,1) NOT NULL DEFAULT '0.0' COMMENT 'Средняя позиция',
  `position_show` decimal(2,1) NOT NULL DEFAULT '0.0' COMMENT 'Средняя позиция показа',
  `position_click` decimal(2,1) NOT NULL DEFAULT '0.0' COMMENT 'Средняя позиция, на которой произошел клик по объявлению',
  `position_value` int(3) NOT NULL DEFAULT '0' COMMENT 'Позиция из Яндекс.XML',
  `show` int(11) NOT NULL DEFAULT '0' COMMENT 'Показы',
  `click` int(11) NOT NULL DEFAULT '0' COMMENT 'Клики',
  `ctr` decimal(5,2) NOT NULL DEFAULT '0.00' COMMENT 'ЦТР',
  `sum` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Расход',
  `show_context` int(11) NOT NULL DEFAULT '0' COMMENT 'Показы РСЯ',
  `click_context` int(11) NOT NULL DEFAULT '0' COMMENT 'Клики РСЯ',
  `ctr_context` decimal(5,2) NOT NULL DEFAULT '0.00' COMMENT 'CTR РСЯ',
  `sum_context` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Сумма потраченная в РСЯ',
  `conversion` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'оличество достигнутых целей Яндекс.Метрики при переходе с поиска',
  `cost` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Цена достижения цели Яндекс.Метрики при переходе с поиска',
  `depth` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Глубина просмотра сайта при переходе с поиска',
  `date` date DEFAULT NULL COMMENT 'Дата',
  PRIMARY KEY (`id`),
  UNIQUE KEY `company` (`company`,`group`,`banner`,`phrase`,`date`),
  KEY `date` (`date`),
  KEY `banner` (`banner`),
  KEY `phrase` (`phrase`),
  KEY `user` (`user`),
  KEY `account` (`account`),
  KEY `group` (`group`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='Таблица статистики' AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Структура таблицы `direct_direct_statistic_price`
--

DROP TABLE IF EXISTS `direct_direct_statistic_price`;
CREATE TABLE IF NOT EXISTS `direct_direct_statistic_price` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT 'Первичный ключ',
  `account` int(11) NOT NULL DEFAULT '0' COMMENT 'Аккунт Яндекс.Директ',
  `user` int(11) NOT NULL DEFAULT '0' COMMENT 'Пользователь',
  `company` int(11) NOT NULL DEFAULT '0' COMMENT 'Компания',
  `group` int(11) NOT NULL DEFAULT '0' COMMENT 'Группа',
  `phrase` bigint(20) NOT NULL DEFAULT '0' COMMENT 'Фраза',
  `currency` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Валюта',
  `price` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Ставка',
  `real_price` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Реальная цена',
  `position` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Позиция',
  `position1` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT '1 место',
  `position2` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT '2 место',
  `position3` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT '3 место',
  `position4` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT '4 место',
  `position5` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT '5 место',
  `position6` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT '6 место',
  `position7` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT '7 место',
  `price1` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Списываемая цена клика за 1 место',
  `price2` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Списываемая цена клика за 2 место',
  `price3` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Списываемая цена клика за 3 место',
  `price4` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Списываемая цена клика за 4 место',
  `price5` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Списываемая цена клика за 5 место',
  `price6` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Списываемая цена клика за 6 место',
  `price7` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Списываемая цена клика за 7 место',
  `context` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Ставка РСЯ',
  `context_percent` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Охват РСЯ',
  `context_max` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Максимальный охват РСЯ',
  `datetime` datetime DEFAULT NULL COMMENT 'Дата и время',
  PRIMARY KEY (`id`),
  KEY `account` (`account`),
  KEY `user` (`user`),
  KEY `company` (`company`),
  KEY `phrase` (`phrase`),
  KEY `group` (`group`),
  KEY `datetime` (`datetime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 DELAY_KEY_WRITE=1 ROW_FORMAT=DYNAMIC COMMENT='Таблица статистики ставок' AUTO_INCREMENT=1 ;
 
-- --------------------------------------------------------

--
-- Структура таблицы `direct_direct_statistic_month`
--

DROP TABLE IF EXISTS `direct_direct_statistic_month`;

-- --------------------------------------------------------




--
-- Структура таблицы `direct_direct_group`
--

CREATE TABLE IF NOT EXISTS `direct_direct_group` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Первичный ключ (совпадает с ID директа)',
  `account` int(11) NOT NULL DEFAULT '0' COMMENT 'Аккаунт Яндекс.Директ',
  `user` int(11) NOT NULL DEFAULT '0' COMMENT 'Клиент',
  `company` int(11) NOT NULL DEFAULT '0' COMMENT 'Ссылка на id компании',
  `banner` int(11) NOT NULL DEFAULT '0' COMMENT 'Объявление',
  `name` varchar(1024) DEFAULT NULL COMMENT 'Наименование группы',
  `domain` varchar(255) DEFAULT NULL COMMENT 'Домен',
  `sum` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Потраченная сумма',
  `show` int(11) NOT NULL DEFAULT '0' COMMENT 'Показы',
  `click` int(11) NOT NULL DEFAULT '0' COMMENT 'Клики',
  `ctr` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'CTR',
  `count` int(11) NOT NULL DEFAULT '0' COMMENT 'Количество фраз в объявлении',
  `show28` int(11) NOT NULL DEFAULT '0' COMMENT 'Показы среднее за 28 дней',
  `click28` int(11) NOT NULL DEFAULT '0' COMMENT 'Клики  среднее за 28 дней',
  `ctr28` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Ctr  среднее за 28 днейРСЯ',
  `strategy` tinyint(1) NOT NULL DEFAULT '0',
  `percent` decimal(10,2) NOT NULL DEFAULT '0.00',
  `add` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Наценка в у.е.',
  `maximum` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Максимальная ставка',
  `fixed` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Фиксированная ставка',
  `budget` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Ограничение дневного бюджета',
  `type` tinyint(1) NOT NULL DEFAULT '0' COMMENT '1 - процент от цены входа, 0 - процент от разницы до первого места',
  `context` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Управлять ставками на тематических площадках',
  `context_percent` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Наценка в процентах для РСЯ',
  `context_type` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Признак разницы до 1 места',
  `context_maximum` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Максимальная ставка для РСЯ',
  `context_fixed` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Фиксированная ставка, если нет данных по охвату аудитории',
  `context_minimum` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Минимальная ставка РСЯ',
  `status` tinyint(1) NOT NULL DEFAULT '0' COMMENT '1 - показывается, 2 - остановлена',
  `plan` int(11) NOT NULL DEFAULT '0' COMMENT 'План на обновление ставок',
  `datetime` datetime DEFAULT NULL COMMENT 'Время обновления ставок',
  `time` datetime DEFAULT NULL COMMENT 'Время обновления',
  PRIMARY KEY (`id`),
  KEY `status` (`status`),
  KEY `account` (`account`),
  KEY `strategy` (`strategy`),
  KEY `user` (`user`),
  KEY `company` (`company`),
  KEY `plan` (`plan`),
  KEY `datetime` (`datetime`),
  KEY `banner` (`banner`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Группы Яндекс.Директ' AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

ALTER TABLE `direct_direct_phrase` ADD `conversion` DECIMAL(10,2) NOT NULL DEFAULT '0' COMMENT 'Конверсии' AFTER `ctr`, ADD `cost` DECIMAL(10,2) NOT NULL DEFAULT '0' COMMENT 'Цена цели' AFTER `conversion`, ADD `depth` DECIMAL(10,2) NOT NULL DEFAULT '0' COMMENT 'Глубина просмотра' AFTER `cost`;

ALTER TABLE `direct_direct_company` ADD `report` DATE NULL DEFAULT NULL COMMENT 'Дата формирования отчета' AFTER `date`,
ADD INDEX (  `report` ) ;

ALTER TABLE `direct_direct_phrase` ADD `show_context28` INT(11) NOT NULL DEFAULT '0' COMMENT 'Показы в РСЯ за 28 дней' AFTER `ctr_context`, ADD `click_context28` INT(11) NOT NULL DEFAULT '0' COMMENT 'Клики в РСЯ за 28 дней' AFTER `show_context28`, ADD `ctr_context28` DECIMAL(10,2) NOT NULL DEFAULT '0' COMMENT 'CTR в РСЯ за 28 дней' AFTER `click_context28`;

ALTER TABLE `direct_direct_company` ADD `sum_context` DECIMAL(10,2) NOT NULL DEFAULT '0' COMMENT 'Расход РСЯ' AFTER `sum`;
ALTER TABLE `direct_direct_group` ADD `sum_context` DECIMAL(10,2) NOT NULL DEFAULT '0' COMMENT 'Расход РСЯ' AFTER `ctr`, ADD `show_context` INT(11) NOT NULL DEFAULT '0' COMMENT 'Показы РСЯ' AFTER `sum_context`, ADD `click_context` INT(11) NOT NULL DEFAULT '0' COMMENT 'Клики РСЯ' AFTER `show_context`, ADD `ctr_context` DECIMAL(10,2) NOT NULL DEFAULT '0' COMMENT 'CTR РСЯ' AFTER `click_context`;
ALTER TABLE `direct_direct_banner` ADD `sum_context` DECIMAL(10,2) NOT NULL DEFAULT '0' COMMENT 'Расход РСЯ' AFTER `sum`;
ALTER TABLE `direct_direct_phrase` ADD `sum_context` DECIMAL(10,2) NOT NULL DEFAULT '0' COMMENT 'Расход РСЯ' AFTER `sum`;

ALTER TABLE `direct_direct_banner` CHANGE `url` `url` VARCHAR(4121) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'Ссылка (ie8 4121байт)';
ALTER TABLE `direct_direct_phrase` CHANGE `name` `name` VARCHAR(4096) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'Наименование';

ALTER TABLE  `direct_direct_phrase` ADD  `context_coverage` VARCHAR( 255 ) NULL DEFAULT NULL COMMENT 'Массив ставок и охватов контекста в JSON' AFTER  `context_max` ;

ALTER TABLE  `direct_direct_banner` ADD  `show28` INT( 11 ) NOT NULL DEFAULT  '0' COMMENT  'Показы на поиске за 28 дней' AFTER  `ctr` ,
ADD  `click28` INT( 11 ) NOT NULL DEFAULT  '0' COMMENT  'Клики на поиске за 28 дней' AFTER  `show28` ,
ADD  `ctr28` DECIMAL( 10, 2 ) NOT NULL DEFAULT  '0' COMMENT  'CTR на поиске за 28 дней' AFTER  `click28` ;

ALTER TABLE  `direct_direct_company` ADD  `plan` INT( 11 ) NOT NULL DEFAULT  '0' COMMENT  'План на обновление ставок' AFTER  `status` ,
ADD INDEX (  `plan` ) ;

TRUNCATE TABLE `direct_direct_group`;

-- AFTER --
INSERT INTO `direct_direct_group` (`id`, `account`, `user`, `company`, `banner`, `name`, `domain`, `strategy`, `percent`, `add`, `maximum`, `fixed`, `budget`, `type`, `context`, `context_percent`, `context_type`, `context_maximum`, `context_fixed`, `context_minimum`, `status`) SELECT `group`, `account`, `user`, `company`, `id`, `name`, `domain`, `strategy`, `percent`, `add`, `maximum`, `fixed`, `budget`, `type`, `context`, `context_percent`, `context_type`, `context_maximum`, `context_fixed`, `context_minimum`, `status` FROM `direct_direct_banner` GROUP BY `group` ORDER BY `status`;
UPDATE `direct_direct_group` `t1` LEFT JOIN `direct_direct_banner` `t2` ON (`t2`.`group`=`t1`.`id`) SET `t1`.`strategy`=`t2`.`strategy`, `t1`.`percent`=`t2`.`percent`, `t1`.`add`=`t2`.`add`, `t1`.`maximum`=`t2`.`maximum`, `t1`.`fixed`=`t2`.`fixed`, `t1`.`budget`=`t2`.`budget`, `t1`.`type`=`t2`.`type`, `t1`.`context`=`t2`.`context`, `t1`.`context_percent`=`t2`.`context_percent`, `t1`.`context_type`=`t2`.`context_type`, `t1`.`context_maximum`=`t2`.`context_maximum`, `t1`.`context_fixed`=`t2`.`context_fixed`, `t1`.`context_minimum`=`t2`.`context_minimum` WHERE `t2`.`strategy`!=0;
-- \AFTER --

ALTER TABLE `direct_direct_banner` CHANGE `name` `name` VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'Заголовок объявления';
ALTER TABLE `direct_direct_banner` CHANGE `body` `body` VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'Текст объявления';

ALTER TABLE  `direct_direct_company` ADD  `datetime` DATETIME NULL DEFAULT NULL COMMENT  'Время обновления ставок' AFTER  `date` ,
ADD INDEX (  `datetime` ) ;

ALTER TABLE  `direct_direct_banner` ADD  `datetime` DATETIME NULL DEFAULT NULL COMMENT  'Время обновления ставок' AFTER  `status` ,
ADD INDEX (  `datetime` ) ;

ALTER TABLE `direct_direct_phrase` CHANGE `second_price` `position2` DECIMAL(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Цена 2 места', CHANGE `down_second_price` `position5` DECIMAL(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Цена 5 места', CHANGE `down_second_price_min` `position6` DECIMAL(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Цена 6 места';
ALTER TABLE `direct_direct_phrase` ADD `price1` DECIMAL(10,2) NULL DEFAULT '0' COMMENT 'Стоимость 1 места' AFTER `min_price`, ADD `price2` DECIMAL(10,2) NULL DEFAULT '0' COMMENT 'Стоимость 2 места' AFTER `price1`, ADD `price3` DECIMAL(10,2) NULL DEFAULT '0' COMMENT 'Стоимость 3 места' AFTER `price2`, ADD `price4` DECIMAL(10,2) NULL DEFAULT '0' COMMENT 'Стоимость 4 места' AFTER `price3`, ADD `price5` DECIMAL(10,2) NULL DEFAULT '0' COMMENT 'Стоимость 5 места' AFTER `price4`, ADD `price6` DECIMAL(10,2) NULL DEFAULT '0' COMMENT 'Стоимость 6 места' AFTER `price5`, ADD `price7` DECIMAL(10,2) NULL DEFAULT '0' COMMENT 'Стоимость 7 места' AFTER `price6`;
ALTER TABLE `direct_direct_phrase` DROP `second_price_min`;

ALTER TABLE  `direct_user_param` 
ADD  `limit` INT( 11 ) NOT NULL DEFAULT  '0' COMMENT  'Количество запросов торгов' AFTER  `user` ,
ADD  `limit_total` INT( 11 ) NOT NULL DEFAULT  '0' COMMENT  'Дневной лимит запросов торгов' AFTER  `limit` ,
ADD  `limit_status` TINYINT( 1 ) NOT NULL DEFAULT  '0' COMMENT  '1 - превышен лимит, 0 - не превышен' AFTER  `limit_total` ,
ADD  `limit_time` DATETIME NULL DEFAULT NULL COMMENT  'Время превышения лимита запросов торгов' AFTER  `limit_status` ,
ADD  `unit` INT( 11 ) NOT NULL DEFAULT  '0' COMMENT  'Количество оставшихся баллов' AFTER  `limit_time` ,
ADD  `unit_total` INT( 11 ) NOT NULL DEFAULT  '0' COMMENT  'Дневной лимит баллов' AFTER  `unit`,
ADD  `unit_status` TINYINT( 1 ) NOT NULL DEFAULT  '0' COMMENT  '1 - превышен лимит, 0 - не превышен' AFTER  `unit_total`,
ADD  `unit_time` DATETIME NULL DEFAULT NULL COMMENT  'Время превышения лимита баллов' AFTER  `unit_status` ;

ALTER TABLE  `direct_direct_banner` ADD  `update` TINYINT( 1 ) NOT NULL DEFAULT  '0' COMMENT  'Текущее обновление ставок' AFTER  `status` ,
ADD INDEX (  `update` ) ;

ALTER TABLE  `direct_direct_phrase` ADD  `datetime` DATETIME NULL DEFAULT NULL COMMENT  'Синхронизация' AFTER  `status` ;

ALTER TABLE  `direct_direct_company` ADD  `show28` INT( 11 ) NOT NULL DEFAULT  '0' COMMENT  'Показы на поиске за 28 дней' AFTER  `ctr` ,
ADD  `click28` INT( 11 ) NOT NULL DEFAULT  '0' COMMENT  'Клики на поиске за 28 дней' AFTER  `show28` ,
ADD  `ctr28` DECIMAL( 10, 2 ) NOT NULL DEFAULT  '0' COMMENT  'CTR на поиске за 28 дней' AFTER  `click28` ;
ALTER TABLE  `direct_direct_company` ADD INDEX ( `ctr28` ) ;

ALTER TABLE  `direct_direct_phrase` ADD  `plan` TINYINT( 1 ) NOT NULL DEFAULT  '0' COMMENT  'План на обновление ставок' AFTER  `status` ,
ADD INDEX (  `plan` ) ;
ALTER TABLE  `direct_direct_phrase` ADD  `show28` INT( 11 ) NOT NULL DEFAULT  '0' COMMENT  'Показы на поиске за 28 дней' AFTER  `ctr` ,
ADD  `click28` INT( 11 ) NOT NULL DEFAULT  '0' COMMENT  'Клики на поиске за 28 дней' AFTER  `show28` ,
ADD  `ctr28` DECIMAL( 10, 2 ) NOT NULL DEFAULT  '0' COMMENT  'CTR на поиске за 28 дней' AFTER  `click28` ;
ALTER TABLE  `direct_direct_phrase` ADD INDEX ( `ctr28` ) ;

ALTER TABLE  `direct_direct_phrase` ADD  `group` INT( 11 ) NOT NULL DEFAULT  '0' COMMENT  'Группа объявлений' AFTER  `company` , ADD INDEX (  `group` ) ;
ALTER TABLE  `direct_direct_phrase` ADD INDEX (  `price` ) ;
ALTER TABLE  `direct_direct_company` ADD INDEX (  `price` ) ;
ALTER TABLE `direct_direct_company` ADD `stop` TINYINT(1) NOT NULL DEFAULT '0' COMMENT 'Остановлена по ограничению дневного бюджета' AFTER `status`;
ALTER TABLE `direct_direct_company` ADD KEY `stop` (`stop`);

ALTER TABLE `direct_direct_phrase` ADD `google_position_value` INT(11) NOT NULL DEFAULT '0' COMMENT 'Позиция в google.ru' AFTER `context_max`;
ALTER TABLE `direct_user` ADD `right` INT(11) NOT NULL DEFAULT '0' COMMENT 'Права' AFTER `group`;
ALTER TABLE `direct_user` ADD KEY `right` (`right`);
UPDATE `direct_user` SET `right`=1;

ALTER TABLE `direct_direct_company` ADD `fixed` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Фиксированная ставка' AFTER `maximum`, ADD `context_minimum` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Минимальная ставка РСЯ' AFTER `context_fixed`;
ALTER TABLE `direct_direct_banner` ADD `fixed` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Фиксированная ставка' AFTER `maximum`, ADD `context_minimum` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Минимальная ставка РСЯ' AFTER `context_fixed`;
ALTER TABLE `direct_direct_phrase` ADD `fixed` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Фиксированная ставка' AFTER `maximum`, ADD `context_minimum` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Минимальная ставка РСЯ' AFTER `context_fixed`;

ALTER TABLE  `direct_direct_banner` COMMENT =  'Объявления Яндекс.директ';
ALTER TABLE  `direct_direct_phrase` COMMENT =  'Фразы Яндекс.директ';

ALTER TABLE `direct_direct_banner` ADD `count` INT(11) NOT NULL DEFAULT '0' COMMENT 'Количество фраз в объявлении' AFTER `ctr`;

ALTER TABLE `direct_direct_banner` ADD `user` INT(11) NOT NULL DEFAULT '0' COMMENT 'Клиент' AFTER `account`, ADD INDEX (`user`) ;
UPDATE `direct_direct_banner` `t1` LEFT JOIN `direct_direct_company` `t2` ON (`t2`.`id`=`t1`.`company`) SET `t1`.`user`=`t2`.`user`;

ALTER TABLE `direct_direct_phrase` ADD `user` INT(11) NOT NULL DEFAULT '0' COMMENT 'Клиент' AFTER `account`, ADD INDEX (`user`) ;
UPDATE `direct_direct_phrase` `t1` LEFT JOIN `direct_direct_banner` `t2` ON (`t2`.`id`=`t1`.`banner`) SET `t1`.`user`=`t2`.`user`;

ALTER TABLE `direct_direct_company` ADD `domain` VARCHAR(255) NULL DEFAULT NULL COMMENT 'Домен' AFTER `name`;

ALTER TABLE `direct_direct_banner` ADD `url` VARCHAR(255) NULL DEFAULT NULL COMMENT 'Ссылка' AFTER `body`, ADD `domain` VARCHAR(255) NULL DEFAULT NULL COMMENT 'Домен' AFTER `url`;

ALTER TABLE `direct_direct_phrase` ADD `position` TINYINT(1) NOT NULL DEFAULT '0' COMMENT 'Включить определение позиций через Яндекс.XML' AFTER `context_max`, ADD `position_value` INT(11) NOT NULL DEFAULT '0' COMMENT 'Значение позиции Яндекс.XML' AFTER `position`, ADD `position_datetime` DATETIME NULL DEFAULT NULL COMMENT 'Время определения позиции Яндекс.XML' AFTER `position_value`;

ALTER TABLE `direct_direct_phrase` ADD INDEX(`position_datetime`);

ALTER TABLE `direct_direct_phrase` ADD INDEX(`position`);

ALTER TABLE `direct_direct_company` ADD INDEX(`strategy`);
ALTER TABLE `direct_direct_banner` ADD INDEX(`strategy`);
ALTER TABLE `direct_direct_phrase` ADD INDEX(`strategy`);

ALTER TABLE  `direct_cron` ADD  `time_limit` INT( 11 ) NOT NULL DEFAULT  '0' COMMENT 'Максимальное время выполнения задания в секундах' AFTER  `time_difference` ;

ALTER TABLE `direct_direct_company` CHANGE `show_avg` `show_context` INT(11) NOT NULL DEFAULT '0' COMMENT 'Показы РСЯ', CHANGE `click_avg` `click_context` INT(11) NOT NULL DEFAULT '0' COMMENT 'Клики РСЯ', CHANGE `ctr_avg` `ctr_context` DECIMAL(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Ctr РСЯ';
ALTER TABLE `direct_direct_banner` CHANGE `show_avg` `show_context` INT(11) NOT NULL DEFAULT '0' COMMENT 'Показы РСЯ', CHANGE `click_avg` `click_context` INT(11) NOT NULL DEFAULT '0' COMMENT 'Клики РСЯ', CHANGE `ctr_avg` `ctr_context` DECIMAL(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Ctr РСЯ';
ALTER TABLE `direct_direct_phrase` CHANGE `show_avg` `show_context` INT(11) NOT NULL DEFAULT '0' COMMENT 'Показы РСЯ', CHANGE `click_avg` `click_context` INT(11) NOT NULL DEFAULT '0' COMMENT 'Клики РСЯ', CHANGE `ctr_avg` `ctr_context` DECIMAL(10,2) NOT NULL DEFAULT '0.00' COMMENT 'Ctr РСЯ';

ALTER TABLE `direct_direct_phrase` ADD `company` INT(11) NOT NULL DEFAULT '0' COMMENT 'Кампания' AFTER `account`, ADD INDEX (`company`) ;
UPDATE `direct_direct_phrase` `t1` LEFT JOIN `direct_direct_banner` `t2` ON (`t2`.`id`=`t1`.`banner`) SET `t1`.`company`=`t2`.`company`;

ALTER TABLE `direct_direct_company` ADD `delete` TINYINT(1) NOT NULL DEFAULT '0' COMMENT '1 - удалить' AFTER `context_fixed`, ADD INDEX (`delete`) ;
ALTER TABLE `direct_direct_banner` ADD `delete` TINYINT(1) NOT NULL DEFAULT '0' COMMENT '1 - удалить' AFTER `context_fixed`, ADD INDEX (`delete`) ;
ALTER TABLE `direct_direct_phrase` ADD `delete` TINYINT(1) NOT NULL DEFAULT '0' COMMENT '1 - удалить' AFTER `ctr_context`, ADD INDEX (`delete`);
ALTER TABLE `direct_cron` ADD `memory` BIGINT NOT NULL DEFAULT '0' COMMENT 'Память' AFTER `interval`;
