<?php 
/////////////////////////////////////////////////////////////
/// Project: FrameWork - фреймворк для веб-разработки     ///
/// Author: Кононенко Станислав Александрович             ///
/// Email: info@direct-automate.ru                        ///
/// Url: http://direct-automate.ru                        ///
/// Language: PHP5.3+                                     ///
/// Charset: UTF-8                                        ///
/////////////////////////////////////////////////////////////
namespace FrameWork\module\api\yandex\direct;
//https://tech.yandex.ru/money/doc/dg/concepts/protocol-request-docpage/
final class Query extends \FrameWork\Common {
	
	public function __construct () {
		parent::__construct();
	}	
	
	public function set($url='', $method='', $PARAM=array()) {
		$this->get($url, $method, $PARAM);
	}
	
	public function get($url='', $method='get', $PARAM=array()) {
		$DATA=array();
		$this->Framework->api->yandex->direct->config->error=0;
		if (!empty($url) && !empty($method) && !empty($PARAM)) {
			$url=preg_match('/^https:\/\//i', $url)?$url:$this->Framework->api->yandex->direct->config->CONFIG['url'].preg_replace('[^a-z]', '', $url).'/';
			$REQUEST=array(
				'method'=>$method, 
				'params'=>$PARAM,
			);
			$HEADER=array(
				'Accept-Language: ru',
				'Content-Type: application/json; charset=utf-8'
			);
			if (!empty($this->Framework->api->yandex->direct->config->CONFIG['token']))
				$HEADER[]='Authorization: Bearer '.$this->Framework->api->yandex->direct->config->CONFIG['token'];
			if (!empty($this->Framework->api->yandex->direct->config->CONFIG['login']))
				$HEADER[]='Client-Login: '.$this->Framework->api->yandex->direct->config->CONFIG['login'];
			
			$request=json_encode($REQUEST);
			
			$allow_url_fopen=ini_get('allow_url_fopen');
			if (function_exists('curl_init')) {
				$ch = curl_init();
				curl_setopt($ch, CURLOPT_URL, $url);
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
				curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
				curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
				curl_setopt($ch,CURLOPT_HTTPHEADER, $HEADER);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); 
				curl_setopt($ch, CURLOPT_POST, 1);
				curl_setopt($ch, CURLOPT_POSTFIELDS, $request);
				curl_setopt($ch, CURLOPT_HEADER, 1);
				$result = curl_exec($ch);
				$position=strpos($result, "{");
				if ($position!==false) {
					$header=substr($result, 0, $position-1);
					$result=substr($result, $position);	
				}
				
				$error_number=curl_errno($ch);
				$error=curl_error($ch);
				curl_close($ch);
			} elseif (!empty($allow_url_fopen)) {
				$opts = array(
					'http'=>array(
						'method'=>"POST",
						'protocol_version' => 1.1,
						'header' => implode("\r\n", $HEADER),
						'content'=>$request,
					)
				); 
				
				# создание контекста потока
				$context = stream_context_create($opts); 
				# отправляем запрос и получаем ответ от сервера
				$result = file_get_contents($url, 0, $context);
				$header=implode("\r\n", $http_response_header);
				$error='';
				$error_number=0;
			} else
				$this->Framework->library->error->set("Не установлена библиотека PHP cURL для доступа к: ".$url.'.', __FILE__, __NAMESPACE__, __CLASS__, __METHOD__, __LINE__);
			
			//Получаем лимиты баллов//
			preg_match("/\r\nUnits: ([0-9]+)\/([0-9]+)\/([0-9]+)\r\n/", $header, $MATCH);
			$this->Framework->api->yandex->direct->config->unit=!empty($MATCH[1])?$MATCH[1]:0;
			$this->Framework->api->yandex->direct->config->limit=!empty($MATCH[2])?$MATCH[2]:0;
			$this->Framework->api->yandex->direct->config->daily=!empty($MATCH[3])?$MATCH[3]:0;
			//\Получаем лимиты баллов//

			if (!$result) {
				$this->Framework->library->error->set("Не удается открыть адрес: ".$url.". (".$error_number.': '.$error.')'.' Время: `'.date('Y-m-d H:i:s'), __FILE__, __NAMESPACE__, __CLASS__, __METHOD__, __LINE__);
			} else {
			$Result=json_decode($result);
				if (!empty($Result->error)) {
					$this->Framework->api->yandex->direct->config->error=$Result->error->error_code;
					$this->Framework->library->error->set('Ошибка АПИ Яндекс.Директ: '. $Result->error->error_code . ' ' . $Result->error->error_string . (!empty($Result->error->error_detail)?'. '.$Result->error->error_detail.'.':'') . ' 1) Идентификатор запроса: '.$Result->error->request_id.' (Баллы: '.(!empty($MATCH[1])?$MATCH[1]:0).'/'.(!empty($MATCH[2])?$MATCH[2]:0).'/'.(!empty($MATCH[3])?$MATCH[3]:0).') 2) Сервис: "'.$url.'" 3) Метод: "'.$method.'" 4) Логин: ' . (!empty($this->Framework->direct->model->config->CONFIG['login'])?$this->Framework->direct->model->config->CONFIG['login']:'') . " 5) Код запроса: ".$request . " 6) Код ответа: ". $result. " 7) Время: ".date('H:i:s d.m.Y'), __FILE__, __NAMESPACE__, __CLASS__, __METHOD__, __LINE__);
				}
				else {
					if (!empty($Result->result))
						$DATA=$this->Framework->library->data->get($Result->result);
					else
						$this->Framework->library->error->set('Hеизвестная ошибка АПИ Яндекс.Директ: 1) Идентификатор запроса: 0 2) Сервис: "'.$url.'" 3) Метод: "'.$method.'" 4) Логин: ' . (!empty($this->Framework->direct->model->config->CONFIG['login'])?$this->Framework->direct->model->config->CONFIG['login']:'') . " 5) Код запроса: ".$request . " 6) Код ответа: ". $header.' '.$result. " 7) Время: ".date('H:i:s d.m.Y'), __FILE__, __NAMESPACE__, __CLASS__, __METHOD__, __LINE__);
				}
			}
		}
		
		return $DATA;
	}
	
	
}//\class
?>