<?php 
/////////////////////////////////////////////////////////////
/// Project: FrameWork - фреймворк для веб-разработки     ///
/// Author: Кононенко Станислав Александрович             ///
/// Email: info@direct-automate.ru                        ///
/// Url: http://direct-automate.ru                        ///
/// Language: PHP5.3+                                     ///
/// Charset: UTF-8                                        ///
/////////////////////////////////////////////////////////////
namespace FrameWork\module\direct\model;

final class Api extends \FrameWork\Common {
	
	public function __construct () {
		parent::__construct();
	}
	
	//Посылка данных//
	public function get($method, $PARAM) {
		$RETURN = array();
		$this->Framework->direct->model->config->error=0;
		if ((int)$this->Framework->CONFIG['debug']==2)
			$time=microtime(true);
		if (isset($method) && isset($PARAM)) {
			// Проверка oAuth токена//
			if (empty($this->Framework->direct->model->config->CONFIG['token']) || ! $this->Framework->direct->model->config->CONFIG['token']) {
				$token=null;
				$this->stop();
				$this->Framework->library->error->set('Отсутствует oAuth токен! Логин: '.$this->Framework->direct->model->config->CONFIG['login'].'.', __FILE__, __NAMESPACE__, __CLASS__, __METHOD__, __LINE__);
			} else {
				$token=$this->Framework->direct->model->config->CONFIG['token'];
			// \Проверка oAuth токена//
				
				// формирование запроса
				$request = array();
				$request['token'] = $token;
				$request['locale'] = 'ru';
				$request['method'] = $method;
				if (!empty($PARAM))
					$request['param'] = $PARAM;
				
				// преобразование в JSON-формат
				$request = json_encode($request);
				$error='';
				for ($i=0; $i<3; $i++) {
					if ($i>0)
						sleep($i);
					$allow_url_fopen=ini_get('allow_url_fopen');
					if (function_exists('curl_init')) {
						$ch = curl_init();
						curl_setopt($ch, CURLOPT_URL, $this->Framework->direct->model->config->CONFIG['api']);
						curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
						curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
						curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
						curl_setopt($ch, CURLOPT_POST, 1);
						curl_setopt($ch, CURLOPT_POSTFIELDS, $request);
						$result = curl_exec($ch);
						$error_number=curl_errno($ch);
						$error=curl_error($ch);
						curl_close($ch);
					} elseif (!empty($allow_url_fopen)) {
						$opts = array(
							'http'=>array(
							'header' => "Content-Type: application/x-www-form-urlencoded\r\n".
								"User-Agent:Direct-automate.ru/".$this->Framework->direct->model->config->CONFIG['version']."\r\n",
								'method'=>"POST",
								'content'=>$request,
							)
						); 
						# создание контекста потока
						$context = stream_context_create($opts); 
						# отправляем запрос и получаем ответ от сервера
						try {
						$result = file_get_contents($this->Framework->direct->model->config->CONFIG['api'], 0, $context);
						} catch (Exception $e) {
							$error=$e->getMessage();
							$error_number=1;
						}
						if (empty($result)) {
							if (empty($error))
								$error='Пустой ответ';
							$error_number=1;
						}
					} else 
						$this->Framework->library->error->set("Не установлена библиотека PHP cURL для доступа к: ".$this->Framework->direct->model->config->CONFIG['api'].'.', __FILE__, __NAMESPACE__, __CLASS__, __METHOD__, __LINE__);
					if (empty($error_number) || $error=='NSS: client certificate not found (nickname not specified)')
						break;
					
				}
				
				if (! $result) {
					//if (!empty($error))
						$this->Framework->library->error->set("Не удается открыть адрес: curl ".$this->Framework->direct->model->config->CONFIG['api'].". (".$error_number.': '.$error . $request.')'.' Время:'.date('Y-m-d H:i:s').' Логин: '.$this->Framework->direct->model->config->CONFIG['login'], __FILE__, __NAMESPACE__, __CLASS__, __METHOD__, __LINE__);
				} else 
					$RETURN = json_decode($result);
			}
		}
		if (isset($RETURN->error_str) && $RETURN->error_str!='Нет статистики для данной кампании') {
			if ($RETURN->error_code==53 || $RETURN->error_code==54 || $RETURN->error_code==58 || $RETURN->error_code==510 || $RETURN->error_code==251 || $RETURN->error_code==513)
				$this->stop();
			$this->Framework->direct->model->config->error=$RETURN->error_code;
			$this->Framework->library->error->set("Запрос {$method}: " . $RETURN->error_str . (!empty($RETURN->error_detail)?'. '.$RETURN->error_detail.'.':'') . '! ' . (!empty($this->Framework->direct->model->config->CONFIG['login'])?"\r\n 1) ".$this->Framework->direct->model->config->CONFIG['login']:'') . "\r\n 2) ".$request . "\r\n 3) ". $result. "\r\n 4) ".date('H:i:s d.m.Y'), __FILE__, __NAMESPACE__, __CLASS__, __METHOD__, __LINE__);
		}
		//$this->Framework->library->error->set("Запрос {$method}: " . (!empty($RETURN->error_str)?'. '.$RETURN->error_str.'.':'') . (!empty($RETURN->error_detail)?'. '.$RETURN->error_detail.'.':'') . '! ' . (!empty($this->Framework->direct->model->config->CONFIG['login'])?"\r\n 1) ".$this->Framework->direct->model->config->CONFIG['login']:'') . "\r\n 2) ".$request . "\r\n 3) ". $result. "\r\n 4) ".date('H:i:s d.m.Y'), __FILE__, __NAMESPACE__, __CLASS__, __METHOD__, __LINE__);
		if ((int)$this->Framework->CONFIG['debug']==2)
			$this->Framework->library->error->set('Запрос Яндекс.Директ API.'.$method.': '.round(microtime(true)-$time, 4).' сек.', '', '', '', '', '');
		return $RETURN; // Возвращаем ответ
	}
	//\Посылка данных//	
	
	private function stop() {
		if (!empty($this->Framework->direct->model->config->CONFIG['login']) && $this->Framework->direct->model->config->CONFIG['login'])
			$this->Framework->user->model->model->set(array('id'=>$this->Framework->direct->model->config->CONFIG['login'], 'status'=>2));
	}
}//\class
?>