<?php 
/////////////////////////////////////////////////////////////
/// Project: FrameWork - фреймворк для веб-разработки     ///
/// Name: Класс контроллер                                ///
/// Author: Кононенко Станислав Александрович             ///
/// Email: info@direct-automate.ru                        ///
/// Url: http://direct-automate.ru                        ///
/// Language: PHP5.3+                                     ///
/// Charset: UTF-8                                        ///
/////////////////////////////////////////////////////////////
namespace FrameWork\module\user\controller;

final class User extends \FrameWork\Common {
	
	public function __construct() {
		parent::__construct();
		
		$this->Framework->library->header->get('http');
	}
	
	public function __get($name) {
		if (isset($this->$name)) {
			return $this->$name;
		} 
		else
			$this->Framework->library->error->set('Нет такого свойства: "'.$name.'".', __FILE__, __NAMESPACE__, __CLASS__, __METHOD__, __LINE__);
		return null;
	}		
	
	private function token($PARAM=array()) {
		//Сохранение токена//
		if (!empty($PARAM['user']) && !empty($PARAM['token'])) {
			$this->Framework->user->model->model->set(array('id'=>$PARAM['user'], 'status'=>1));
			$this->Framework->user->model->param->set(array('user'=>$PARAM['user'], 'token'=>$PARAM['token']));
			return 'Токен получен';
		}
		//\Сохранение токена//
	}
	
	private function refresh($PARAM=array()) {
		if (!empty($PARAM) && !is_array($PARAM))
			$PARAM=array('id'=>$PARAM);
		//Обновление статуса и пересинхронизация//
		if (!empty($PARAM['id'])) {
			$this->Framework->user->model->model->set(array('id'=>$PARAM['user'], 'status'=>1));
			$this->Framework->db->set("UPDATE `".$this->Framework->direct->model->config->TABLE['company']."` SET `time`=NULL WHERE `account`='".$PARAM['id']."'");
			return 'Токен получен';
		}
		//\Обновление статуса и пересинхронизация//
	}
	
	public function get($PARAM=array()) {
		if (!empty($PARAM) && !is_array($PARAM))
			$PARAM=array('id'=>$PARAM);
		$DATA=array();
		if ($this->Framework->user->controller->controller->USER && $this->Framework->user->controller->controller->USER['group']>=1) {
			$this->Framework->template->set('USER', $this->Framework->user->controller->controller->USER);
			$DATA['CONFIG']=$this->Framework->direct->model->config->CONFIG;
			$DATA['COUNT']=$this->Framework->direct->statistic->count->get();
			if (!empty($PARAM['refresh']))
				$DATA['USER']['refresh']=$this->refresh(!empty($PARAM['id'])?$PARAM['id']:0);
			$DATA['USER']['message']=$this->token(array('user'=>!empty($PARAM['user'])?(is_array($PARAM['user'])?$PARAM['user'][0]:$PARAM['user']):0, 'token'=>!empty($PARAM['token'])?(is_array($PARAM['token'])?$PARAM['token'][0]:$PARAM['token']):''));
			if ($this->Framework->user->controller->controller->USER['group']==3)
				$PARAM['parent']=$this->Framework->user->controller->controller->USER['id'];
			if (!empty($PARAM) && is_array($PARAM)) {
				$DATA['USER']=$this->Framework->user->model->model->get($PARAM, array('login'), array(), array('page'=>(!empty($PARAM['page'])?(int)$PARAM['page']:0), 'number'=>500));
				$DATA['USER']['PARAM']=$PARAM;
				$DATA['PARAM']=$PARAM;
			}
			
		}
		$this->Framework->template->set('DATA', $DATA);
		echo $this->Framework->template->get('user.html');
	}
	
	public function edit($PARAM=array()) {
		if (!empty($PARAM) && !is_array($PARAM))
			$PARAM=array('id'=>$PARAM);
		$DATA=array();
		if ($this->Framework->user->controller->controller->USER && $this->Framework->user->controller->controller->USER['group']>=1) {
			$this->Framework->template->set('USER', $this->Framework->user->controller->controller->USER);
			$DATA['CONFIG']=$this->Framework->direct->model->config->CONFIG;
			$DATA['USER']['message']=$this->token(array('user'=>!empty($PARAM['user'])?(is_array($PARAM['user'])?$PARAM['user'][0]:$PARAM['user']):0, 'token'=>!empty($PARAM['token'])?(is_array($PARAM['token'])?$PARAM['token'][0]:$PARAM['token']):''));
			if (!empty($PARAM['id'])) 
				$DATA['USER']=$this->Framework->user->model->model->get(array('id'=>$PARAM['id']));
			$DATA['USER']['PARAM']=$PARAM;
			
		}
		$this->Framework->template->set('DATA', $DATA);
		echo $this->Framework->template->get('user.html');
	}	

	public function save($PARAM=array()) {
		if (empty($PARAM))
			$PARAM=$_REQUEST;
		$DATA=array('status'=>0);
		if ($this->Framework->user->controller->controller->USER && ($this->Framework->user->controller->controller->USER['group']==1 || $this->Framework->user->controller->controller->USER['group']==3 || (($this->Framework->user->controller->controller->USER['group']==4 || $this->Framework->user->controller->controller->USER['group']==2) && !empty($PARAM['id']) && $PARAM['id']==$this->Framework->user->controller->controller->USER['id']))) {
			if ($this->Framework->user->controller->controller->USER['group']>1 && !$this->Framework->user->controller->controller->USER['right']>0)
				unset($PARAM['right']);
			$PARAM['status']=1; 
			if (!empty($PARAM['login']))
				$PARAM['login']=trim(preg_replace('/@.+/', '', $PARAM['login']));
			$DATA['id']=$this->Framework->user->model->model->set($PARAM);
			if (!empty($DATA['id'])) {
				$PARAM['user']=$DATA['id'];
				$this->Framework->user->model->param->set($PARAM);
				$DATA['status']=1;
			}
		}
		$this->Framework->template('json')->set('DATA', $DATA);
		echo $this->Framework->template('json')->get();
	}
	
}//\class
?>